#include <iostream>

using namespace std;

int main()
{
    long long int n, m, i, j;
    cin>>n>>m;
    long long int t[n+1][m+1];
    long long int seged[n+1][m+1];
    for(i=0;i<n+1;i++)
    {
        t[i][0]=INT_MAX;
        seged[i][0]=INT_MAX;
    }
    for(i=0;i<m;i++)
    {
        t[0][i]=INT_MAX;
        seged[0][i]=INT_MAX;
    }
    for(i=1;i<n+1;i++)
        for(j=1;j<m+1;j++)
            cin>>t[i][j];
    long long int q;
    cin>>q;
    long long int eredmeny[q];
    long long int tarol;
    long long int x, y;
    for(long long int k=0;k<q;k++)
    {
        for(i=1;i<n+1;i++)
            for(j=1;j<m+1;j++)
                seged[i][j]=0;
        cin>>x>>y;
        tarol=t[x][y];
        t[x][y]=INT_MAX;
        seged[1][1]=t[1][1];
        for(i=1;i<n+1;i++)
            for(j=1;j<m+1;j++)
            {
                if(!(j==1 && i==1))
                {
                    if(seged[i-1][j]<seged[i][j-1])
                        seged[i][j]=seged[i-1][j]+t[i][j];
                    else
                        seged[i][j]=seged[i][j-1]+t[i][j];
                }
            }

        /*for(i=1;i<n+1;i++)
        {
            for(j=1;j<m+1;j++)
                cout<<seged[i][j]<<" ";
            cout<<endl;

        }*/
        eredmeny[k]=seged[n][m];
        t[x][y]=tarol;
    }
    for(int k=0;k<q;k++)
        cout<<eredmeny[k]<<endl;

    return 0;
}